// ArrayTest.cpp : Defines the exported functions for the DLL application.
//
#include "stdafx.h"
#include <WinUser.h>
#include <string>

using namespace std;

#define MT4_EXPFUNC __declspec(dllexport)

#pragma pack(push,1)
struct BinData
{	int Number;
	double Amplitude;
	int Frequency;
};
#pragma pack(pop)


MT4_EXPFUNC void _stdcall ArrayTestingFunction(BinData *Bins) {

	// Check that a value is passed to the DLL from MQL
	double value = Bins[1000000].Amplitude;
	string test1 = "Passed Amplitude Value " + to_string(Bins[1000000].Amplitude);
	MessageBoxA(NULL, test1.c_str(), "DLL Message", MB_OK | MB_ICONINFORMATION);

	// Change the value so that we see something different in MQL
	Bins[1000000].Amplitude = value * 2;

	// Display the changed data before returning to MQL
	string test2 = "New Amplitude Value "+to_string(Bins[1000000].Amplitude);
	MessageBoxA(NULL, test2.c_str(), "DLL Message", MB_OK | MB_ICONINFORMATION);
}

